diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 38c3de3..bd22feb 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,5 +1,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
+	* dv-bfin_uart.c [!HAVE_DV_SOCKSER] (dv_sockser_status,
+	dv_sockser_write, dv_sockser_read): Delete.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
 	* sim-main.h: Delete run-sim.h include.
 
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/bfin/dv-bfin_uart.c b/sim/bfin/dv-bfin_uart.c
index b40cccb..0460ca5 100644
--- a/sim/bfin/dv-bfin_uart.c
+++ b/sim/bfin/dv-bfin_uart.c
@@ -74,12 +74,6 @@ static const char *mmr_name (struct bfin_uart *uart, bu32 idx)
 }
 #define mmr_name(off) mmr_name (uart, (off) / 4)
 
-#ifndef HAVE_DV_SOCKSER
-# define dv_sockser_status(sd) -1
-# define dv_sockser_write(sd, byte) do { ; } while (0)
-# define dv_sockser_read(sd) 0xff
-#endif
-
 static void
 bfin_uart_poll (struct hw *me, void *data)
 {
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index d3b8642..c82f105 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,3 +1,11 @@
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* dv-sockser.c: Include config.h.
+	* dv-sockser.h: Include sim-inline.h.
+	[HAVE_DV_SOCKSER]: Move all prototypes here.
+	[!HAVE_DV_SOCKSER] (dv_sockser_status, dv_sockser_write,
+	dv_sockser_write_buffer, dv_sockser_read): New stub functions.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* gentmap.c, run.c: Convert old style prototypes.
diff --git a/sim/common/dv-sockser.c b/sim/common/dv-sockser.c
index ac6fb50..313fa4f 100644
--- a/sim/common/dv-sockser.c
+++ b/sim/common/dv-sockser.c
@@ -18,6 +18,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 /* FIXME: will obviously need to evolve.
    - connectionless sockets might be more appropriate.  */
 
+#include "config.h"
 #include "sim-main.h"
 
 #ifdef HAVE_STRING_H
diff --git a/sim/common/dv-sockser.h b/sim/common/dv-sockser.h
index cc4fd74..1fd1c12 100644
--- a/sim/common/dv-sockser.h
+++ b/sim/common/dv-sockser.h
@@ -19,11 +19,15 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 #ifndef DV_SOCKSER_H
 #define DV_SOCKSER_H
 
+#include "sim-inline.h"
+
 /* bits in result of dev_sockser_status */
 #define DV_SOCKSER_INPUT_EMPTY  0x1
 #define DV_SOCKSER_OUTPUT_EMPTY 0x2
 #define DV_SOCKSER_DISCONNECTED 0x4
 
+#ifdef HAVE_DV_SOCKSER
+
 /* FIXME: later add a device ptr arg */
 extern int dv_sockser_status (SIM_DESC);
 int dv_sockser_write (SIM_DESC, unsigned char);
@@ -32,4 +36,37 @@ int dv_sockser_read (SIM_DESC);
 
 SIM_RC dv_sockser_install (SIM_DESC);
 
+#else
+
+/* If dv-sockser isn't available, provide stub functions.  */
+
+STATIC_INLINE int
+dv_sockser_status (SIM_DESC sd)
+{
+  return (DV_SOCKSER_INPUT_EMPTY  |
+	  DV_SOCKSER_OUTPUT_EMPTY |
+	  DV_SOCKSER_DISCONNECTED);
+}
+
+STATIC_INLINE int
+dv_sockser_write (SIM_DESC sd, unsigned char c)
+{
+  return -1;
+}
+
+STATIC_INLINE int
+dv_sockser_write_buffer (SIM_DESC sd, const unsigned char *buffer,
+			 unsigned nr_bytes)
+{
+  return -1;
+}
+
+STATIC_INLINE int
+dv_sockser_read (SIM_DESC sd)
+{
+  return -1;
+}
+
+#endif /* HAVE_DV_SOCKSER */
+
 #endif /* DV_SOCKSER_H */
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index f8c3494..5c8e6eb 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,3 +1,8 @@
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+	* configure.ac: Delete sim_hw checks for dv-sockser.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/mips/configure b/sim/mips/configure
index 39c20b9..650b6bb 100755
diff --git a/sim/mips/configure.ac b/sim/mips/configure.ac
index 4565379..02deab6 100644
--- a/sim/mips/configure.ac
+++ b/sim/mips/configure.ac
@@ -422,15 +422,6 @@ SIM_AC_OPTION_HARDWARE($hw_enabled,$hw_devices,$hw_extra_devices)
 mips_extra_objs="$SIM_DV_SOCKSER_O"
 AC_SUBST(mips_extra_objs)
 
-if test "$sim_hw_p" = yes -a -z "$SIM_DV_SOCKSER_O"; then
-	case " $sim_hw " in
-	*" tx3904sio "*)
-		AC_MSG_ERROR([Sorry, but tx3904sio hardware support is
-unavailable for your target.  Please use --disable-sim-hardware, or pass a
-list of devices to enable that does not include that.])
-	esac
-fi
-
 
 # Choose simulator engine
 case "${target}" in
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index bdf8b2c..9a6cc45 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,8 @@
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+	* configure.ac: Delete SIM_DV_SOCKSER_O check.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index 9cba769..f0a650a 100755
diff --git a/sim/mn10300/configure.ac b/sim/mn10300/configure.ac
index c9050c1..ec29024 100644
--- a/sim/mn10300/configure.ac
+++ b/sim/mn10300/configure.ac
@@ -19,10 +19,4 @@ AC_CHECK_HEADERS(utime.h)
 
 SIM_AC_OPTION_HARDWARE(always,"","")
 
-if test -z "$SIM_DV_SOCKSER_O"; then
-	AC_MSG_ERROR([Sorry, but hardware support in this simulator
-unconditionally relies on dv-sockser.o which is unavailable for your host.
-Please fix this simulator.])
-fi
-
 SIM_AC_OUTPUT