diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 1619cfc..4d2619c 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,6 +1,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
 	* configure.ac (BFIN_SIM_EXTRA_OBJS): Delete.
 	* Makefile.in (SIM_OBJS): Delete @BFIN_SIM_EXTRA_OBJS@.
 
diff --git a/sim/bfin/configure b/sim/bfin/configure
index ecd911a..f3e2a7a 100755
diff --git a/sim/common/acinclude.m4 b/sim/common/acinclude.m4
index e4d206f..3e9fb2f 100644
--- a/sim/common/acinclude.m4
+++ b/sim/common/acinclude.m4
@@ -585,7 +585,7 @@ AC_SUBST(sim_default_model)
 
 
 dnl --enable-sim-hardware is for users of the simulator
-dnl arg[1] Enable sim-hw by default? ("yes", "no", or "always")
+dnl arg[1] Enable sim-hw by default? ("yes" or "no")
 dnl arg[2] is a space separated list of devices that override the defaults
 dnl arg[3] is a space separated list of extra target specific devices.
 AC_DEFUN([SIM_AC_OPTION_HARDWARE],
@@ -611,18 +611,13 @@ AC_ARG_ENABLE(sim-hardware,
   [AS_HELP_STRING([--enable-sim-hardware=LIST],
                   [Specify the hardware to be included in the build.])])
 case ${enable_sim_hardware} in
-  yes)  sim_hw_p=yes;;
-  no)   sim_hw_p=no;;
-  ,*)   sim_hw_p=yes; hardware="${hardware} `echo ${enableval} | sed -e 's/,/ /'`";;
-  *,)   sim_hw_p=yes; hardware="`echo ${enableval} | sed -e 's/,/ /'` ${hardware}";;
-  *)    sim_hw_p=yes; hardware="`echo ${enableval} | sed -e 's/,/ /'`"'';;
+  yes|no) ;;
+  ,*) hardware="${hardware} `echo ${enableval} | sed -e 's/,/ /'`";;
+  *,) hardware="`echo ${enableval} | sed -e 's/,/ /'` ${hardware}";;
+  *)  hardware="`echo ${enableval} | sed -e 's/,/ /'`"'';;
 esac
 
-if test "$sim_hw_p" != yes; then
-  if test "[$1]" = "always"; then
-    AC_MSG_ERROR([Sorry, but this simulator requires that hardware support
-be enabled. Please configure without --disable-hw-support.])
-  fi
+if test "$enable_sim_hardware" = no; then
   sim_hw_objs=
   sim_hw_cflags="-DWITH_HW=0"
   sim_hw=
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index 8d2905f..d587122 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -7,6 +7,10 @@
 
 	* configure: Regenerate.
 
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* aclocal.m4, config.in, configure: Regenerate.
diff --git a/sim/cris/configure b/sim/cris/configure
index a36a3eb..08bc681 100755
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index 1ae319c..d7f23f1 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,5 +1,9 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
+	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
 	* devices.c: Delete dv-sockser.h include.
 	(device_io_read_buffer): Delete uart code.
 	(device_io_write_buffer): Likewise.
diff --git a/sim/frv/configure b/sim/frv/configure
index 847c4bb..06f015f 100755
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index 85aedad..d5acc6c 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -7,6 +7,10 @@
 
 	* configure: Regenerate.
 
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* aclocal.m4, config.in, configure: Regenerate.
diff --git a/sim/iq2000/configure b/sim/iq2000/configure
index 97aeed1..cbf6674 100755
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index 3ea4b85..653c10d 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,6 +1,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
 	* Makefile.in (SIM_OBJS): Delete @SIM_DV_SOCKSER_O@.
 
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/lm32/configure b/sim/lm32/configure
index fd4185f..6a52056 100755
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index b2261b2..e5d013e 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -2,6 +2,10 @@
 
 	* configure: Regenerate.
 
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
 
 	* aclocal.m4, config.in, configure: Regenerate.
diff --git a/sim/m32r/configure b/sim/m32r/configure
index 7dbcdf0..dc22e7f 100755
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index 35f1e18..67815b1 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,6 +1,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
 	* configure.ac (m68hc11_extra_objs): Delete.
 	* Makefile.in (SIM_OBJS): Delete SIM_EXTRA_OBJS.
 	(SIM_EXTRA_OBJS): Delete.
diff --git a/sim/m68hc11/configure b/sim/m68hc11/configure
index 7d559e6..e056512 100755
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 60275b0..6f3c938 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,6 +1,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
 	* configure.ac (mips_extra_objs): Delete.
 	* Makefile.in (MIPS_EXTRA_OBJS): Delete.
 	(SIM_OBJS): Delete MIPS_EXTRA_OBJS.
diff --git a/sim/mips/configure b/sim/mips/configure
index 792d77c..60c1cf8 100755
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index 3750b8a..d188dda 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -13,6 +13,10 @@
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
 	* configure.ac: Delete SIM_DV_SOCKSER_O check.
 
 2015-03-16  Mike Frysinger  <vapier@gentoo.org>
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index c9185d1..5c0327a 100755
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 5ce0cfe..b96e542 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -4,6 +4,10 @@
 
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
+	* configure: Regenerate.
+
+2015-03-23  Mike Frysinger  <vapier@gentoo.org>
+
 	* Makefile.in (CONFIG_DEVICES): Delete.
 	(SIM_OBJS): Delete CONFIG_DEVICES.
 