diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 4d2619c..d0615a8 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/bfin/configure b/sim/bfin/configure
index f3e2a7a..2aa9563 100755
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index 1cfb4d3..655d98a 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,3 +1,8 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* acinclude.m4 (SIM_AC_OPTION_HARDWARE): Move default option setting
+	of enable_sim_hardware to AC_ARG_ENABLE.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* acinclude.m4 (SIM_AC_OPTION_HARDWARE): Delete SIM_DV_SOCKSER_O.
diff --git a/sim/common/acinclude.m4 b/sim/common/acinclude.m4
index 3e9fb2f..6522fea 100644
--- a/sim/common/acinclude.m4
+++ b/sim/common/acinclude.m4
@@ -590,12 +590,6 @@ dnl arg[2] is a space separated list of devices that override the defaults
 dnl arg[3] is a space separated list of extra target specific devices.
 AC_DEFUN([SIM_AC_OPTION_HARDWARE],
 [
-if test x"[$1]" != x"no"; then
-  enable_sim_hardware=yes
-else
-  enable_sim_hardware=no
-fi
-
 if test "[$2]"; then
   hardware="[$2]"
 else
@@ -609,7 +603,8 @@ sim_hw_objs="\$(SIM_COMMON_HW_OBJS) `echo $sim_hw | sed -e 's/\([[^ ]][[^ ]]*\)/
 
 AC_ARG_ENABLE(sim-hardware,
   [AS_HELP_STRING([--enable-sim-hardware=LIST],
-                  [Specify the hardware to be included in the build.])])
+                  [Specify the hardware to be included in the build.])],
+  ,[enable_sim_hardware="[$1]"])
 case ${enable_sim_hardware} in
   yes|no) ;;
   ,*) hardware="${hardware} `echo ${enableval} | sed -e 's/,/ /'`";;
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index d587122..4a8d181 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (CONFIG_DEVICES): Delete.
diff --git a/sim/cris/configure b/sim/cris/configure
index 08bc681..7b3795c 100755
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index d7f23f1..2e4f8b6 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/frv/configure b/sim/frv/configure
index 06f015f..39a1567 100755
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index d5acc6c..1f95a08 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (CONFIG_DEVICES): Delete.
diff --git a/sim/iq2000/configure b/sim/iq2000/configure
index cbf6674..49c0f3a 100755
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index 653c10d..8d917b4 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/lm32/configure b/sim/lm32/configure
index 6a52056..d1110fa 100755
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index e5d013e..48f2e47 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/m32r/configure b/sim/m32r/configure
index dc22e7f..bd17e87 100755
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index 67815b1..fc18f38 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/m68hc11/configure b/sim/m68hc11/configure
index e056512..1fccfb5 100755
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 6f3c938..d5f8ec0 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.
diff --git a/sim/mips/configure b/sim/mips/configure
index 60c1cf8..03f34f2 100755
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index d188dda..cf8a025 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* Makefile.in (MN10300_OBJS): Delete dv-sockser.o.
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index 5c0327a..d539b06 100755
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index b96e542..8c3c872 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,3 +1,7 @@
+2015-03-24  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure: Regenerate.
+
 2015-03-23  Mike Frysinger  <vapier@gentoo.org>
 
 	* configure: Regenerate.