diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 921be9d..2168726 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,3 +1,7 @@
+2015-04-01  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete $(SIM_EXTRA_OBJS).
+
 2015-03-31  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/bfin/Makefile.in b/sim/bfin/Makefile.in
index a3dfd9f..10178d1 100644
--- a/sim/bfin/Makefile.in
+++ b/sim/bfin/Makefile.in
@@ -35,8 +35,7 @@ SIM_OBJS = \
 	sim-reason.o \
 	sim-reg.o \
 	sim-resume.o \
-	sim-stop.o \
-	$(SIM_EXTRA_OBJS)
+	sim-stop.o
 
 INCLUDE = bfin-sim.h
 
diff --git a/sim/ft32/ChangeLog b/sim/ft32/ChangeLog
index 7e87c63..d74e390 100644
--- a/sim/ft32/ChangeLog
+++ b/sim/ft32/ChangeLog
@@ -1,3 +1,7 @@
+2015-04-01  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete $(SIM_EXTRA_OBJS).
+
 2015-03-31  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/ft32/Makefile.in b/sim/ft32/Makefile.in
index f16039a..e8c9bb5 100644
--- a/sim/ft32/Makefile.in
+++ b/sim/ft32/Makefile.in
@@ -42,7 +42,6 @@ SIM_OBJS = \
 	sim-signal.o	\
 	sim-stop.o	\
 	sim-trace.o	\
-	sim-utils.o	\
-	$(SIM_EXTRA_OBJS)
+	sim-utils.o
 
 ## COMMON_POST_CONFIG_FRAG
diff --git a/sim/h8300/ChangeLog b/sim/h8300/ChangeLog
index 037568b..641f72d 100644
--- a/sim/h8300/ChangeLog
+++ b/sim/h8300/ChangeLog
@@ -1,3 +1,7 @@
+2015-04-01  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete $(SIM_EXTRA_OBJS).
+
 2015-03-31  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/h8300/Makefile.in b/sim/h8300/Makefile.in
index 0333a56..8893f80 100644
--- a/sim/h8300/Makefile.in
+++ b/sim/h8300/Makefile.in
@@ -1,7 +1,7 @@
 #    Makefile template for Configure for the h8300 sim library.
 #    Copyright (C) 1990-2015 Free Software Foundation, Inc.
 #    Written by Cygnus Support.
-# 
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 3 of the License, or
@@ -21,8 +21,7 @@ SIM_OBJS = compile.o \
 	   $(SIM_NEW_COMMON_OBJS) \
 	   sim-cpu.o \
 	   sim-engine.o \
-	   sim-load.o \
-	   $(SIM_EXTRA_OBJS)
+	   sim-load.o
 
 ## COMMON_POST_CONFIG_FRAG
 
diff --git a/sim/msp430/ChangeLog b/sim/msp430/ChangeLog
index 4f2793d..29ff2f7 100644
--- a/sim/msp430/ChangeLog
+++ b/sim/msp430/ChangeLog
@@ -1,3 +1,7 @@
+2015-04-01  Mike Frysinger  <vapier@gentoo.org>
+
+	* Makefile.in (SIM_OBJS): Delete $(SIM_EXTRA_OBJS).
+
 2015-03-31  Mike Frysinger  <vapier@gentoo.org>
 
 	* config.in, configure: Regenerate.
diff --git a/sim/msp430/Makefile.in b/sim/msp430/Makefile.in
index 2034867..a7f3dee 100644
--- a/sim/msp430/Makefile.in
+++ b/sim/msp430/Makefile.in
@@ -1,17 +1,17 @@
 #    Makefile template for Configure for the MSP430 sim library.
 #    Copyright 2012-2015 Free Software Foundation, Inc.
 #    Written by Red Hat Inc.
-# 
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 3 of the License, or
 # (at your option) any later version.
-# 
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
@@ -25,18 +25,17 @@
 
 # List of object files, less common parts.
 SIM_OBJS = \
-        $(SIM_NEW_COMMON_OBJS) \
-        msp430-sim.o \
+	$(SIM_NEW_COMMON_OBJS) \
+	msp430-sim.o \
 	trace.o \
-        sim-cpu.o \
-        sim-engine.o \
-        sim-hload.o \
-        sim-hrw.o \
-        sim-reason.o \
-        sim-reg.o \
-        sim-resume.o \
-        sim-stop.o \
-        $(SIM_EXTRA_OBJS)
+	sim-cpu.o \
+	sim-engine.o \
+	sim-hload.o \
+	sim-hrw.o \
+	sim-reason.o \
+	sim-reg.o \
+	sim-resume.o \
+	sim-stop.o \
 
 # List of extra dependencies.
 # Generally this consists of simulator specific files included by sim-main.h.